$IF 0

         TASTCODE.BAS         

  Dieses Programm wurde in PowerBasic 3.1 geschrieben. Bei anderen    
  Basic-Dialekten mu ggf. eine Anpassung durchgefhrt werden.        
  Voraussetzung ist allerdings, das Ihr Basic Assemblerbefehle unter- 
  sttzt. (Integrierter Assembler)                                    
  05.01.96 / 28.01.96                                                 

Fr Anregungen bin ich dankbar. Wenden Sie sich bei Problemen bitte an
           Martin Hupler, Thann 6, D 92681 Erbendorf                 
                  Telefon/-fax: 09682/3888                            

  


'                             EINFHRUNG
                             

  Sie sind  sicherlich schon  das eine  oder andere Mal  vor dem Problem
  gestanden, mehrere Tastenanschlge bzw. Tastenkombinationenen parallel
  verarbeiten zu mssen. Hintereinander kann man ja leicht die Tastenan-
  schlge  abfragen,  egal ob mit  der BASIC-Funktion  INKEY$  oder  dem
  Interrupt 16H.  Aber wenn man  z.B. in einem  Spiel berprfen mu, ob
  die  Tasten  PfeilLinks  und  PfeilOben  gleichzeitig  gedrckt  sind,
  scheitern  diese  Methoden,  weil man nicht mitbekommt,  wann  die ge-
  drckte Taste wieder losgelassen wird.

  In dem nachfolgenden Beispiel ist eine Mglichkeit aufgezeigt. Es wird
  der Tastatur-Interrupt 09H auf eine eigene Routine verbogen. Der  alte
  Tastaturhandler  wird jedoch  nicht mehr  aufgerufen, d.h. Sie  mssen
  jede  Tastatureingabe  selbst abarbeiten (bei Programmabsturz funktio-
  niert nicht einmal mehr Strg+Alt+Entf).

  Wie geht dies?

  Jedesmal, wenn man eine Taste drckt oder loslt, sendet die Tastatur
  an den  Rechner eine Code,  bei manchen Tasten  sogar 2 Codes  hinter-
  einander ( Die  Leer-Taste sendet  sogar 5  verschiedene Codes ). Beim
  Drcken einer Taste  den sogenannten MAKE-Code und  beim Loslassen den
  BREAK-Code.

  Wenn nun der Interrupt 09H aufgerufen wird, liest das Programm aus dem
  Port 60H  den dort  abgelegten Code  ein  und speichert ihn  an  einer
  Stelle im  Codesegment (LABEL: TastaturCode),  da man  darauf  whrend
  eines Interrupts leichter zugreifen kann als auf das Datensegment.
  Im Hauptprogramm  (DO ... LOOP - Schleife)  wird nun der Code wiederum
  in  die Variable "Taste%" gelesen  und  anschlieend  mit einem Status
  "TastenStatus%" verglichen.  Kommt nun der MAKE-Code einer Pfeiltaste,
  wird  der "TastenStatus%" erhht,  und bleibt  solange  um diesen Wert
  erhht, bis der BREAK-Code dieser Pfeiltaste eintrifft.

  Zur Visualisierung  wird im Programm ein Klotz ""  auf dem Bildschirm
  dargestellt, der mit Hilfe der Kursortasten ber den Bildschirm bewegt
  werden kann.  So ist es  nun mglich,  den Klotz nicht nur  nach links
  oder oben, sondern auch nach linksoben wandern zu lassen.

  In der Version vom 05.06.96 war  das Problem die Geschwindigkeit. Dies
  kam daher,  da der alte Tastaturhandler aufgerufen wurde,  der in den
  Tastaturpuffer schreibt.  Dieser Puffer mute jedoch  mit INT 16H aus-
  gelesen werden.  Leider sendet  die Tastatur erst nach  einer gewissen
  Verzgerung  weiterhin Codes,  wenn eine Taste  gedrckt  bleibt.  Vor
  allem in Spielen ist dieses Verhalten jedoch meist nicht gewnscht.

  So habe ich das Programm etwas umgeschrieben.
  Der alte Tastaturhandler wird nun nicht mehr aufgerufen. Man mu jetzt
  jedoch den Interrupt selbst ordungsgem abschlieen (OUT-Befehl). War
  im Beispiel vom 5.1.96 die mangelnde  Geschwindigkeit ein Problem, ist
  es hier genau umgekehrt: Der Klotz "" wird so schnell verschoben, da
  er am anderen  Bildschirmrand angelangt ist,  bevor man es mitbekommt.
  Deshalb habe ich noch eine Konstante %Verzoegerung eingefhrt, mit der
  man die Reaktionsgeschwindigkeit des Programmes verndern kann.



  Martin Hupler                                   Thann, den 28.01.1996

$ENDIF



' =========================  Programmanfang ================================

$ERROR ALL OFF
$LIB ALL OFF

 KlotzLoeschen% = 0			' Wenn <> 0, dann wird der Klotz auf
					' dem Bildschirm zuvor gelscht und
					' an der neuen Stelle ausgegeben
					'    ====== Ausprobieren ======


' Ŀ
'  Konstante fr die Programmverzgerung definieren                       
' 
 %Verzoegerung = 5000


' Ŀ
'  Konstanten fr die Pfeiltasten definieren                              
' 
 %Nix    = 0				' Keine Taste bettigt
 %Rauf   = 1				' Taste PfeilOben   - UP
 %Runter = 2				' Taste PfeilUnten  - DOWN
 %Links  = 4				' Taste PfeilLinks  - LEFT
 %Rechts = 8				' Taste PfeilRechts - RIGHT

' Ŀ
'  Variablen fr den Programmablauf vorbesetzen                           
' 
 TastenStatus% = 0			' Dient als Container fr die vorher
					' definierten Pfeiltasten-Konstanten

 Taste% = 0				' Diese Variable gibt den Inhalt ...
					' des Tastencodes auf Bildschirm aus

 Zeile% = 12				'default Bildschirmzeile des Klotzes
 Spalte% = 40				'...und Bildschirmspalte des Klotzes





' Ŀ
'  Zeiger auf den aktuellen Interrupt-Handler INT 09H ermitteln           
' 
 CALL GetInterruptVektor(&H09,OSG09??,OPR09??)



' Ŀ
'  Die Stelle des neuen Interrupt-Handlers im Programmcode ermitteln      
' 
  SG09??=CODESEG(NewInt09)	'NewInt09 ist ein Label im Programm
  PR09??=CODEPTR(NewInt09)


' Ŀ
'  Den Interrupt INT 09 auf die neue Stelle des Programmcodes setzten     
' 
 CALL SetInterruptVektor(&H09,SG09??,PR09??)



' Ŀ
'  Verzgerung, bis die Wiederholung eintritt auf 1/4 Sekunde in BH       
'  Wiederholungsrate auf 30 pro Sekunde in BL                             
' 
 ! MOV AH, &H03
 ! MOV AL, &H05
 ! MOV BH, 0
 ! MOV BL, 0
 ! INT &H16






' Ŀ
'  Bildschirm vorbereiten                                                 
' 
 cls
 print "HEX", " DEZ", "Status"
 print HEX$(Taste%),Taste%,TastenStatus%
 locate Zeile%+1, Spalte%+1			' Klotz auf Bildschirm ...
 print ""					' ... ausgeben
 locate 25, 15
 print "Programm beenden mit ESC (aber erst beim Loslassen)";



' Ŀ
'  DO ... LOOP - Schleife als Hauptprogramm. Wird mit ESC verlassen       
' 
do
 !
 ! LEA BX, TastaturCode			; Adresse von TastaturCode nach BX
 ! MOV AX, CS:[BX]			; Inhalt von TastaturCode nach AX...
 ! MOV Taste%, AX			; und in Variable Taste% speichern

 incr Durchlauf&			' Variable fr Verzgerung

 if Durchlauf& = %Verzoegerung or Taste% <> LetzteTaste% then
  if Taste% <> LetzteTaste% then LetzteTaste% = Taste%
  SELECT CASE Taste%
   CASE 75				' ... wenn Pfeil-Links gedrckt
     if (TastenStatus% AND %Links) = 0 then
       TastenStatus% = TastenStatus% or %Links	' .... Bit setzen
     end if
   CASE 203				' ... wenn Pfeil-Links losgelassen
     if (TastenStatus% AND %Links) <> 0 then
       TastenStatus% = TastenStatus% xor %Links	' ... Bit lschen
     end if
   CASE 77				' ... wenn Pfeil-Rechts gedrckt
     if (TastenStatus% AND %Rechts) = 0 then
       TastenStatus% = TastenStatus% or %Rechts
     end if
   CASE 205				' ... wenn Pfeil-Rechts losgelassen
     if (TastenStatus% AND %Rechts) <> 0 then
       TastenStatus% = TastenStatus% xor %Rechts
     end if
   CASE 72				' ... wenn Pfeil-Oben gedrckt
     if (TastenStatus% AND %Rauf) = 0 then
       TastenStatus% = TastenStatus% or %Rauf
     end if
   CASE 200				' ... wenn Pfeil-Oben losgelassen
     if (TastenStatus% AND %Rauf) <> 0 then
       TastenStatus% = TastenStatus% xor %Rauf
     end if
   CASE 80				' ... wenn Pfeil-Unten gedrckt
     if (TastenStatus% AND %Runter) = 0 then
       TastenStatus% = TastenStatus% or %Runter
     end if
   CASE 208				' ... wenn Pfeil-Unten losgelassen
     if (TastenStatus% AND %Runter) <> 0 then
       TastenStatus% = TastenStatus% xor %Runter
     end if
   END SELECT

' Ŀ
'  Der Klotz wird an aktueller Stelle gelscht (mit Leerzeichen ber-     
'  schrieben). Dies geschieht ber den Interrupt 10H                      
' 
   if KlotzLoeschen% then
'   locate Zeile%, Spalte%
     ! MOV AH, &H02
     ! MOV BH, pbvScrnApage		;pbvScrnApage ist normalerweise 0
     ! MOV DH, Zeile%
     ! MOV DL, Spalte%
     ! INT &H10
'   print " "
     ! MOV AH, &H0A
     ! MOV AL, 32
     ! MOV BH, pbvScrnApage		;pbvScrnApage ist normalerweise 0
     ! MOV CX, 1
     ! INT &H10				; Klotz an alter Stelle loeschen
   end if

' Ŀ
'   Da die Pfeiltasten nicht nur einen, sondern sogar 2 (und wenn die     
'   NUM-Taste ein ist, sogar 3 BREAK-Codes) MAKE- und BREAK-Codes senden, 
'   werden diese erweiterten Codes unbercksichtigt gelassen.             
' 
   if Taste% > 71 and Taste% < 209 then
     if (TastenStatus% AND %Rauf) <> 0 and Zeile% > 0 then decr Zeile%
     if (TastenStatus% AND %Links) <> 0 and Spalte% > 0 then decr Spalte%
     if (TastenStatus% AND %Rechts) <> 0 and Spalte% < 79 then incr Spalte%
     if (TastenStatus% AND %Runter) <> 0 and Zeile% < 24 then incr Zeile%
   end if


' Ŀ
'  Tastencode auf Bildschirm ausgeben. Ist allerdings eine recht langsame 
'  Methode, und kann unter Umstnden dazu fhren, da der Tastatur-       
'  Handler den Inhalt in TASTATURCODE	berschreibt, bevor er augelesen   
'  werden konnte. Auch der LOCATE-Befehl ist recht langsam                
' 
   LOCATE 2,1
   print HEX$(Taste%),Taste%,TastenStatus%



' Ŀ
'  Um den Klotz auf dem Bildschirm auszugeben, wird nun der langsame      
'  PRINT-Befehl durch Ausgabe ber das BIOS benutzt.                      
'  Die Variable "pbvScrnApage" ist eine interne PowerBasic-Variable,      
'  und beinhaltet die Nummer der aktuellen Bildschirmseite.               
' 
' Nachfolgendes entspricht Basic-Befehl:  LOCATE Zeile%, Spalte%
   ! MOV AH, &H02
   ! MOV BH, pbvScrnApage		;pbvScrnApage ist normalerweise 0
   ! MOV DH, Zeile%
   ! MOV DL, Spalte%
   ! INT &H10
' Nachfolgendes entspricht Basic-Befehl:  PRINT CHR$(178)
   ! MOV AH, &H0A
   ! MOV AL, 178
   ! MOV BH, pbvScrnApage		;pbvScrnApage ist normalerweise 0
   ! MOV CX, 1
   ! INT &H10

   Durchlauf& = 0
  END IF

 LOOP WHILE Taste% <> &H81	' Raus, wenn Esc-Taste losgelassen

 'Vor dem Programmende den alten Interrupt-Handler INT 09 restaurieren
 CALL SetInterruptVektor(&H09,OSG09??,OPR09??)

 cls
 print "Programm TASTODE beendet!"
 END					' H   -   das Programm stirbt



TastaturCode:
 ! DW 0			; Hier wird der Tastaturcode gespeichert!



NewInt09:
 !	CLI				; Interrupt-Enable-Flag loeschen
 !	PUSHF				; Prozessor-Flags auf den Stack
 !      PUSH    AX			; Nachfolgende Register muss man
 !	PUSH    BX			; sicherlich nicht alle retten,
 !	PUSH    CX			; aber hier:
 !	PUSH    DX			; ...
 !	PUSH    SI			; ...
 !	PUSH    DI			; ...
 !	PUSH    BP			; ...
 !	PUSH    DS			; ...
 !	PUSH    ES			; ... sicher ist sicher!
 !	XOR AX, AX
 !	in al, &H60
 !	LEA BX, TastaturCode
 !	mov CS:[BX], ax
 !	MOV AL, &H20			; Interruptabschluss vor- ...
 !	OUT &H20, AL			; ... bereiten (Wichtig!!!)
 !	POP	ES
 !	POP     DS
 !	POP     BP
 !	POP     DI
 !	POP     SI
 !	POP     DX
 !	POP     CX
 !	POP     BX
 !	POP     AX
 !	POPF
 !	iret				; Interrupt beenden





' Ŀ
'  Mit Hilfe der DOS-Interrupt-Funktion &H25 kann ein beliebiger          
'  Interrupt-Vektor auf eine andere Routine verbogen werden.              
'  Vor Aufruf dieser Funktion sollte zunchst der alte Inhalt des         
'  zu verndernden Interrupt-Vektors mit Hilfe der Funktion &H35          
'  ausgelesen und gespeichert werden. Nach Beendigung des Programmes      
'  sollte sein alter Inhalt dann mit Hilfe dieser Funktion restauriert    
'  werden.                                                                
' 
 SUB SetInterruptVektor(Intr%,Segment??,Offset??)
 REG 1,&H2500 + Intr%
 REG 4,Offset??
 REG 8,Segment??
 CALL INTERRUPT &H21
 END SUB


' Ŀ
'  Die DOS-Interrupt-Funktion &H35 liefert als Resultat den aktuellen     
'  Inhalt eines Interrupt-Vektors und damit die Adresse der zugehrigen   
'  Interrupt-Routine zurck                                               
' 
 SUB GetInterruptVektor(Intr%,Segment??,Offset??)
 REG 1,&H3500 + Intr%
 CALL INTERRUPT &H21
 Segment??=REG(9)
 Offset??=REG(2)
 END SUB

'EOF  >  End of File  > Dateiende